//
// CDDL HEADER START
//
// The contents of this file are subject to the terms of the Common Development
// and Distribution License Version 1.0 (the "License").
//
// You can obtain a copy of the license at
// http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
// specific language governing permissions and limitations under the License.
//
// When distributing Covered Code, include this CDDL HEADER in each file and
// include the License file in a prominent location with the name LICENSE.CDDL.
// If applicable, add the following below this CDDL HEADER, with the fields
// enclosed by brackets "[]" replaced with your own identifying information:
//
// Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
//
// CDDL HEADER END
//

//
// Copyright (c) 2016--2020, Regents of the University of Minnesota.
// All rights reserved.
//
// Contributors:
//    Ryan S. Elliott
//

//
// Release: This file is part of the kim-api-2.2.1 package.
//


#include <cstddef>

#ifndef KIM_FUNCTION_TYPES_HPP_
#include "KIM_FunctionTypes.hpp"
#endif

extern "C" {
#ifndef KIM_FUNCTION_TYPES_H_
#include "KIM_FunctionTypes.h"  // IWYU pragma: keep
#endif
}

#ifndef KIM_LANGUAGE_NAME_HPP_
#include "KIM_LanguageName.hpp"
#endif

#ifndef KIM_COLLECTION_ITEM_TYPE_HPP_
#include "KIM_CollectionItemType.hpp"
#endif

#ifndef KIM_SHARED_LIBRARY_SCHEMA_HPP_
#include "KIM_SharedLibrarySchema.hpp"
#endif


using namespace KIM::SHARED_LIBRARY_SCHEMA;

extern "C" {
// clang-format off
int kim_shared_library_schema_version = 2;



extern unsigned int const smspec_edn_len;
extern unsigned char const smspec_edn[];
extern unsigned int const Alchemy_PbAu_in_len;
extern unsigned char const Alchemy_PbAu_in[];
extern unsigned int const item_compiled_with_version_txt_len;
extern unsigned char const item_compiled_with_version_txt[];
extern unsigned int const kimcite_Sim_LAMMPS_LJcut_AkersonElliott_Alchemy_PbAu_bib_len;
extern unsigned char const kimcite_Sim_LAMMPS_LJcut_AkersonElliott_Alchemy_PbAu_bib[];

static SharedLibrarySchemaV2::EmbeddedFile const SM_SPEC_FILE_Files[] = {
  {"smspec.edn", smspec_edn_len, smspec_edn}
};
static SharedLibrarySchemaV2::EmbeddedFile const PARAMETER_FILE_Files[] = {
  {"Alchemy_PbAu.in", Alchemy_PbAu_in_len, Alchemy_PbAu_in}
};
static SharedLibrarySchemaV2::EmbeddedFile const METADATA_FILE_Files[] = {
  {"item-compiled-with-version.txt", item_compiled_with_version_txt_len, item_compiled_with_version_txt},
  {"kimcite-Sim_LAMMPS_LJcut_AkersonElliott_Alchemy_PbAu.bib", kimcite_Sim_LAMMPS_LJcut_AkersonElliott_Alchemy_PbAu_bib_len, kimcite_Sim_LAMMPS_LJcut_AkersonElliott_Alchemy_PbAu_bib}
};

SharedLibrarySchemaV2 kim_shared_library_schema = {
    KIM::COLLECTION_ITEM_TYPE::simulatorModel,  // Item Type
    "Sim_LAMMPS_LJcut_AkersonElliott_Alchemy_PbAu",  // Item Name
    KIM::LANGUAGE_NAME::cpp,  // Create Routine Language
    reinterpret_cast<KIM::Function *>(NULL),  // Create Routine Name
    NULL,  // Item Driver Name
    SM_SPEC_FILE_Files,  // smspec File
    1,  // Number of Parameter Files
    PARAMETER_FILE_Files,  // Embedded Parameter Files
    2,  // Number of Metadata Files
    METADATA_FILE_Files  // Embedded Metadata Files
};
}
// clang-format on
